Files
apfstests/tests/xfs/533
T
Chandan Babu R febeb7ec8b xfs/53[238]: Disable realtime inherit flag
The minimum length space allocator (i.e.
xfs_bmap_exact_minlen_extent_alloc()) depends on the underlying
filesystem to be fragmented so that there are enough one block sized
extents available to satify space allocation requests.

xfs/{532,533,538} tests issue space allocation requests for metadata
(e.g. for blocks holding directory and xattr information). With
realtime filesystem instances, these tests would end up fragmenting
the space on realtime device. Hence minimum length space allocator
fails since the regular filesystem space is not fragmented and hence
there are no one block sized extents available.

Thus, this commit disables realtime inherit flag (if any) on root
directory so that space on data device gets fragmented rather than
realtime device.

Suggested-by: Darrick J. Wong <djwong@kernel.org>
Reported-by: Darrick J. Wong <djwong@kernel.org>
Signed-off-by: Chandan Babu R <chandanrlinux@gmail.com>
Reviewed-by: Darrick J. Wong <djwong@kernel.org>
Signed-off-by: Eryu Guan <guaneryu@gmail.com>
2021-04-11 16:49:26 +08:00

187 lines
4.6 KiB
Bash
Executable File

#! /bin/bash
# SPDX-License-Identifier: GPL-2.0
# Copyright (c) 2021 Chandan Babu R. All Rights Reserved.
#
# FS QA Test 533
#
# Verify that XFS does not cause inode fork's extent count to overflow when
# adding/removing directory entries.
seq=`basename $0`
seqres=$RESULT_DIR/$seq
echo "QA output created by $seq"
here=`pwd`
tmp=/tmp/$$
status=1 # failure is the default!
trap "_cleanup; exit \$status" 0 1 2 3 15
_cleanup()
{
cd /
rm -f $tmp.*
}
# get standard environment, filters and checks
. ./common/rc
. ./common/filter
. ./common/inject
. ./common/populate
# remove previous $seqres.full before test
rm -f $seqres.full
# real QA test starts here
_supported_fs xfs
_require_scratch
_require_xfs_debug
_require_test_program "punch-alternating"
_require_xfs_io_error_injection "reduce_max_iextents"
_require_xfs_io_error_injection "bmap_alloc_minlen_extent"
_scratch_mkfs_sized $((1024 * 1024 * 1024)) | _filter_mkfs >> $seqres.full 2> $tmp.mkfs
. $tmp.mkfs
# Filesystems with directory block size greater than one FSB will not be tested,
# since "7 (i.e. XFS_DA_NODE_MAXDEPTH + 1 data block + 1 free block) * 2 (fsb
# count) = 14" is greater than the pseudo max extent count limit of 10.
# Extending the pseudo max limit won't help either. Consider the case where 1
# FSB is 1k in size and 1 dir block is 64k in size (i.e. fsb count = 64). In
# this case, the pseudo max limit has to be greater than 7 * 64 = 448 extents.
if (( $dirbsize > $dbsize )); then
_notrun "Directory block size ($dirbsize) is larger than FSB size ($dbsize)"
fi
echo "Format and mount fs"
_scratch_mkfs_sized $((1024 * 1024 * 1024)) >> $seqres.full
_scratch_mount >> $seqres.full
# Disable realtime inherit flag (if any) on root directory so that space on data
# device gets fragmented rather than realtime device.
$XFS_IO_PROG -c 'chattr -t' $SCRATCH_MNT
echo "Consume free space"
fillerdir=$SCRATCH_MNT/fillerdir
nr_free_blks=$(stat -f -c '%f' $SCRATCH_MNT)
nr_free_blks=$((nr_free_blks * 90 / 100))
_fill_fs $((dbsize * nr_free_blks)) $fillerdir $dbsize 0 >> $seqres.full 2>&1
echo "Create fragmented filesystem"
for dentry in $(ls -1 $fillerdir/); do
$here/src/punch-alternating $fillerdir/$dentry >> $seqres.full
done
echo "Inject reduce_max_iextents error tag"
_scratch_inject_error reduce_max_iextents 1
echo "Inject bmap_alloc_minlen_extent error tag"
_scratch_inject_error bmap_alloc_minlen_extent 1
dent_len=255
echo "* Create directory entries"
testdir=$SCRATCH_MNT/testdir
mkdir $testdir
nr_dents=$((dbsize * 20 / dent_len))
for i in $(seq 1 $nr_dents); do
dentry="$(printf "%0255d" $i)"
touch ${testdir}/$dentry >> $seqres.full 2>&1 || break
done
echo "Verify directory's extent count"
nextents=$(_xfs_get_fsxattr nextents $testdir)
if (( $nextents > 10 )); then
echo "Extent count overflow check failed: nextents = $nextents"
exit 1
fi
rm -rf $testdir
echo "* Rename: Populate destination directory"
dstdir=$SCRATCH_MNT/dstdir
mkdir $dstdir
nr_dents=$((dirbsize * 20 / dent_len))
echo "Populate \$dstdir by moving new directory entries"
for i in $(seq 1 $nr_dents); do
dentry="$(printf "%0255d" $i)"
dentry=${SCRATCH_MNT}/${dentry}
touch $dentry || break
mv $dentry $dstdir >> $seqres.full 2>&1 || break
done
rm $dentry
echo "Verify \$dstdir's extent count"
nextents=$(_xfs_get_fsxattr nextents $dstdir)
if (( $nextents > 10 )); then
echo "Extent count overflow check failed: nextents = $nextents"
exit 1
fi
rm -rf $dstdir
echo "* Create multiple hard links to a single file"
testdir=$SCRATCH_MNT/testdir
mkdir $testdir
testfile=$SCRATCH_MNT/testfile
touch $testfile
nr_dents=$((dirbsize * 20 / dent_len))
echo "Create multiple hardlinks"
for i in $(seq 1 $nr_dents); do
dentry="$(printf "%0255d" $i)"
ln $testfile ${testdir}/${dentry} >> $seqres.full 2>&1 || break
done
rm $testfile
echo "Verify directory's extent count"
nextents=$(_xfs_get_fsxattr nextents $testdir)
if (( $nextents > 10 )); then
echo "Extent count overflow check failed: nextents = $nextents"
exit 1
fi
rm -rf $testdir
echo "* Create multiple symbolic links to a single file"
testdir=$SCRATCH_MNT/testdir
mkdir $testdir
testfile=$SCRATCH_MNT/testfile
touch $testfile
nr_dents=$((dirbsize * 20 / dent_len))
echo "Create multiple symbolic links"
for i in $(seq 1 $nr_dents); do
dentry="$(printf "%0255d" $i)"
ln -s $testfile ${testdir}/${dentry} >> $seqres.full 2>&1 || break;
done
rm $testfile
echo "Verify directory's extent count"
nextents=$(_xfs_get_fsxattr nextents $testdir)
if (( $nextents > 10 )); then
echo "Extent count overflow check failed: nextents = $nextents"
exit 1
fi
rm -rf $testdir
# success, all done
status=0
exit